[PATCH weston 25/25] doc: add example calibration-helper script

Pekka Paalanen ppaalanen at gmail.com
Fri Mar 23 12:01:05 UTC 2018


From: Pekka Paalanen <pekka.paalanen at collabora.co.uk>

This is not to be installed, except maybe as a doc. It is just an
example of what one might do.  It also has not been tested, it's just
for giving an idea of what it should do.

It also contains untested speculation.

Signed-off-by: Pekka Paalanen <pekka.paalanen at collabora.co.uk>
---
 Makefile.am                 |  1 +
 doc/calibration-helper.bash | 44 ++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 45 insertions(+)
 create mode 100755 doc/calibration-helper.bash

diff --git a/Makefile.am b/Makefile.am
index dad7e8ac..5985a964 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1594,6 +1594,7 @@ SUFFIXES = .1 .5 .7 .man
 	$(AM_V_GEN)$(SED) $(MAN_SUBSTS) < $< > $@
 
 EXTRA_DIST +=					\
+	doc/calibration-helper.bash		\
 	man/weston.man				\
 	man/weston-drm.man			\
 	man/weston-rdp.man			\
diff --git a/doc/calibration-helper.bash b/doc/calibration-helper.bash
new file mode 100755
index 00000000..6fefbf2e
--- /dev/null
+++ b/doc/calibration-helper.bash
@@ -0,0 +1,44 @@
+#!/bin/bash
+
+# This is an example script working as Weston's calibration helper.
+# Its purpose is to permanently store the calibration matrix for the given
+# touchscreen input device into a udev property. Since this script naturally
+# runs as the user that runs Weston, it presumably cannot write directly into
+# /etc. It is left for the administrator to set up appropriate files and
+# permissions.
+
+# To use this script, one needs to edit weston.ini, in section [libinput], add:
+#   calibration_helper=/path/to/bin/calibration-helper.bash
+
+# exit immediately if any command fails
+set -e
+
+# The arguments Weston gives us:
+DEVPATH="$1"
+MATRIX="$2 $3 $4 $5 $6 $7"
+
+# Pick something to recognize the right touch device with.
+# Usually one would use something like a serial.
+SERIAL=$(udevadm info --path="$DEVPATH" --query=property | \
+	awk -- 'BEGIN { FS="=" } { if ($1 == "ID_SERIAL") { print $2; exit } }')
+
+# If cannot find a serial, tell the server to not use the new calibration.
+[ -z "$SERIAL" ] && exit 1
+
+# Well, one could match simply with DEVPATH=="$DEVPATH"...
+
+# You'd have this write a file instead.
+echo "ACTION==\"add|change\",SUBSYSTEM==\"input\",ENV{ID_SERIAL}==\"$SERIAL\",ENV{LIBINPUT_CALIBRATION_MATRIX}=\"$MATRIX\""
+
+# Then you'd tell udev to reload the rules:
+#udevadm control --reload
+# This lets Weston get the new calibration if you unplug and replug the input
+# device. Instead of writing a udev rule directly, you could have a udev rule
+# with IMPORT{file}="/path/to/calibration", write
+# "LIBINPUT_CALIBRATION_MATRIX=\"$MATRIX\"" into /path/to/calibration instead,
+# and skip this reload step.
+
+# Make udev process the new rule by triggering a "change" event:
+#udevadm trigger "$DEVPATH"
+# If you were to restart Weston without rebooting, this lets it pick up the new
+# calibration.
-- 
2.16.1



More information about the wayland-devel mailing list